package com.codegeist.fisheye.domain.query;

import org.junit.Test;

public class AuthorInRestrictionTest extends AbstractRestrictionTest {
	
	@Test(expected=IllegalArgumentException.class)
	public void testNullAuthorsTag() throws Exception {
		generateEyeQl(new AuthorInRestriction(null));
	}
	
	@Test(expected=IllegalArgumentException.class)
	public void testEmptyAuthorsTag() throws Exception {
		generateEyeQl(new AuthorInRestriction(new String[0]));
	}

	@Test(expected=IllegalArgumentException.class)
	public void testNullEntry() throws Exception {
		generateEyeQl(new AuthorInRestriction(new String[] {null}));
	}
	
	@Test
	public void testSingleAuthor() throws Exception {
		checkEyeQl("author in (author1)", new AuthorInRestriction(new String[] {"author1"}));
	}
	
	@Test
	public void testMultipleAuthors() throws Exception {
		checkEyeQl("author in (author1, author2)", new AuthorInRestriction(new String[] {"author1", "author2"}));
	}
}
