package com.codegeist.fisheye.internal.service;

import com.codegeist.fisheye.domain.Revision;
import com.codegeist.fisheye.domain.Revision.State;

public class RevisionHandlerTest extends AbstractHandlerTest<RevisionHandler> {

	@Override
	protected RevisionHandler createHandler() {
		return new RevisionHandler();
	}

	public void testEmpty() throws Exception {
		startDocument();
		endDocument();
		
		Revision result = handler.getResult();
		assertNotNull(result);
	}
	
	public void testRevision() throws Exception {
		String[] names = {
				"path",
				"rev",
				"author",
				"date",
				"state",
				"totalLines",
				"linesAdded",
				"linesRemoved",
				"csid",
		};
		
		String[] values = {
				"",
				"1",
				"mutombo",
				"2006-08-15T11:48:07.91Z",
				"added",
				"0",
				"0",
				"0",
				"1",
		};
		
		startDocument();
		startElement("revision", names, values);
		endElement("revision");
		startElement("log");
		characters("Mega cool log message");
		endElement("log");
		endDocument();
		Revision result = handler.getResult();
		assertNotNull(result);
		
		assertEquals("", result.getKey().getPath());
		assertEquals("1", result.getKey().getRev());
		assertEquals("mutombo", result.getAuthor());
		assertEquals("1", result.getChangesetId());
		assertEquals(State.ADDED, result.getState());
		assertEquals("Mega cool log message", result.getLog());
	}
	
}
