package com.codegeist.fisheye.domain;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;

// TODO add unit tests for this, or remove the need for it entirely
public final class DateConverter {
	private static SimpleDateFormat format;
	
	static {
		format = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss'Z'");
		format.setTimeZone(TimeZone.getTimeZone("GMT"));
	}

	private DateConverter() {
	}
	
	public static Date asDate(String dateString) {
		if (dateString == null || dateString.length() == 0) {
			return null;
		}
		
		synchronized (format) {
			try {
				return format.parse(dateString);
			} catch (ParseException e) {
				return null;
			}
		}
	}
	
	public static String asString(Date date) {
		synchronized (format) {
			return format.format(date);
		}
	}
}
