package com.codegeist.fisheye.internal.service;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import com.codegeist.fisheye.domain.RevisionKey;

public class RevisionKeyHandler extends DefaultHandler implements Handler<RevisionKey>{
	private StringBuilder buffer = new StringBuilder();
	private RevisionKey result;
	private String revision;
	private String path;
	
	@Override
	public void startDocument() throws SAXException {
		revision = null;
		path = null;
	}

	@Override
	public void startElement(String uri, String localName, String name, Attributes attributes) throws SAXException {
		if ("revisionkey".equals(localName)) {
			revision = StringRegistry.internRev(attributes.getValue("rev"));
			path = StringRegistry.internPath(attributes.getValue("path"));
		}
		buffer.setLength(0);
	}
	
	@Override
	public void endElement(String uri, String localName, String name) throws SAXException {
		buffer.setLength(0);
	}
	
	
	@Override
	public void endDocument() throws SAXException {
		result = new RevisionKey(path, revision);
	}
	
	@Override
	public void characters(char[] ch, int start, int length) throws SAXException {
		buffer.append(ch, start, length);
	}
	
	public RevisionKey getResult() {
		return result;
	}
}
